# coding: utf-8

"""
    HiddenLayer-API

    HiddenLayer-API

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from hiddenlayer.sdk.rest.models.artifact_content import ArtifactContent
from hiddenlayer.sdk.rest.models.property_bag import PropertyBag
from typing import Optional, Set
from typing_extensions import Self

class WebResponse(BaseModel):
    """
    Describes the response to an HTTP request.
    """ # noqa: E501
    index: Optional[Annotated[int, Field(strict=True, ge=-1)]] = Field(default=-1, description="The index within the run.webResponses array of the response object associated with this result.")
    protocol: Optional[StrictStr] = Field(default=None, description="The response protocol. Example: 'http'.")
    version: Optional[StrictStr] = Field(default=None, description="The response version. Example: '1.1'.")
    status_code: Optional[StrictInt] = Field(default=None, description="The response status code. Example: 451.", alias="statusCode")
    reason_phrase: Optional[StrictStr] = Field(default=None, description="The response reason. Example: 'Not found'.", alias="reasonPhrase")
    headers: Optional[Dict[str, StrictStr]] = Field(default=None, description="The response headers.")
    body: Optional[ArtifactContent] = None
    no_response_received: Optional[StrictBool] = Field(default=False, description="Specifies whether a response was received from the server.", alias="noResponseReceived")
    properties: Optional[PropertyBag] = None
    __properties: ClassVar[List[str]] = ["index", "protocol", "version", "statusCode", "reasonPhrase", "headers", "body", "noResponseReceived", "properties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of body
        if self.body:
            _dict['body'] = self.body.to_dict()
        # override the default output from pydantic by calling `to_dict()` of properties
        if self.properties:
            _dict['properties'] = self.properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "index": obj.get("index") if obj.get("index") is not None else -1,
            "protocol": obj.get("protocol"),
            "version": obj.get("version"),
            "statusCode": obj.get("statusCode"),
            "reasonPhrase": obj.get("reasonPhrase"),
            "headers": obj.get("headers"),
            "body": ArtifactContent.from_dict(obj["body"]) if obj.get("body") is not None else None,
            "noResponseReceived": obj.get("noResponseReceived") if obj.get("noResponseReceived") is not None else False,
            "properties": PropertyBag.from_dict(obj["properties"]) if obj.get("properties") is not None else None
        })
        return _obj


